package com.aitrainer.api.service

import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import org.thymeleaf.TemplateEngine
import org.thymeleaf.context.Context

@Service
class EmailTemplateService {
    @Autowired
    private var templateEngine: TemplateEngine? = null

    fun getEmailBody(firstname: String, activationLink: String): String {
        val context = Context()
        context.setVariable("firstname", firstname)
        context.setVariable("activationLink", activationLink)
        if ( templateEngine == null) {
            templateEngine = TemplateEngine()
        }
        return templateEngine!!.process("registration_email", context)
    }

    fun getSubject(): String {
        val context = Context()
        if ( templateEngine == null) {
            templateEngine = TemplateEngine()
        }
        return templateEngine!!.process("registration_subject", context)
    }
}

