package com.aitrainer.api.test

import com.aitrainer.api.controller.CustomerMembershipController
import com.aitrainer.api.model.Customer
import com.aitrainer.api.model.CustomerMembership
import com.aitrainer.api.repository.CustomerMembershipRepository
import com.aitrainer.api.repository.CustomerRepository
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.http.HttpStatus
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class CustomerMembershipTest {

    @Autowired
    private lateinit var customerMembershipRepository: CustomerMembershipRepository

    @Autowired lateinit var customerRepository: CustomerRepository


    @Test
    fun testCustomerMembershipByCustomerId() {
        val controller = CustomerMembershipController(customerMembershipRepository, customerRepository )
        val response = controller.getAllByCustomerId(90)

        val properties = response.body

        assertTrue(properties is List)
        assertTrue(properties.isNotEmpty())
        assertEquals(properties.size, 2)
    }

    @Test
    fun testInsert() {
      /*  val foundCustomer: Customer? = customerRepository.findByCustomerIdAndActive(90, "Y")
        val customerMembership = CustomerMembership(
            membershipId = 3,
            startDate = "2023-01-30",
        )
        customerMembership.customer = foundCustomer

        val controller = CustomerMembershipController(customerMembershipRepository, customerRepository)
        val response = controller.createNewCustomerMembership(customerMembership)

        val newCustomerMembership = response.body

        assertTrue(newCustomerMembership is CustomerMembership)
        customerMembershipRepository.delete(newCustomerMembership) // does not delete the customer_membership
        */
    }
}