package com.aitrainer.api.test

import com.aitrainer.api.service.Email
import com.aitrainer.api.service.EmailTemplateService
import jakarta.mail.MessagingException
import org.junit.jupiter.api.BeforeAll
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertTrue


@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class EmailTest {
    private lateinit var email: Email

    @Autowired
    private lateinit var emailTemplateService: EmailTemplateService

    @BeforeAll
    fun tearUp() {
        this.email = Email()
    }

    @Test
    fun testTemplate() {
        val html = emailTemplateService.getEmailBody("Tibor", "https://very.link")
        print(html)
        assertTrue (html.isNotEmpty())
        assertTrue(html.contains("Tibor"))
    }
    @Test
    fun testSend() {

        try {
            email.send("tibor.bossanyi@aitrainer.app", "<h1>Üdv</h1><p>id=932989</p>", "Workout Test API test")
            assertTrue(true)
        } catch (e: MessagingException) {
            println("Error sending email: $e")
            assertTrue(false)
        }



    }
}